SystemOrganization addCategory: #'CS528su13-Tiki'!

Object subclass: #TikiPage
	instanceVariableNames: 'orderedLinks linkDictionary summary id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 16:38'!
newFrom:aString id: anID summary: aSummary
|tempPage|
tempPage:=TikiPage new.
tempPage id:anID summary:aSummary.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 16:59'!
id
^id! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 16:38'!
id: anid summary: aSummary
id:=anid.
summary:=aSummary.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 13:28'!
initialize 
linkDictionary:=Dictionary new.
orderedLinks:=OrderedCollection new.
summary:=''.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:30'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempID tempText tempLength tempIndex|

rawLinkList:=aString findTokens:$#.
"linkDictionary:= Dictionary new."
orderedLinks removeAll.
(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ].

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempID:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength. orderedLinks add:tempID. linkDictionary at: (tempID asSymbol) put: tempText].
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:29'!
orderedLinks
^orderedLinks! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:42'!
summary
^summary! !

Object subclass: #TikiSerializable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSerializable commentStamp: '<historical>' prior: 0!
The pages and pop-up windows are rendered when they are needed by the web, or, they are opened by user clicks.

TikiSerialiable instances represent these objects. They can be edited by users and serialized into disk.
!

TikiSerializable subclass: #TikiPageFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 16:05'!
style 
	^'a:link {color:black; text-decoration:none}
	a:visited{color:black; text-decoration:none}
	a:hover { color:gray; text-decoration:none} 
	a:active { color:black; text-decoration:none'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'allPages mainInput currentPage editting expanded tenerquePage tenerPage infinitivePage agreementPage mainPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:38'!
findPageWithId: anID among: pagesCollection 
"This should be replaced when ID checking improves"
^(pagesCollection detect: [:eachpage| eachpage id = anID] ifNone: mainPage).! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:05'!
initialize
| temp |
super initialize.
editting:=false.
mainInput:='Test input'.
"currentPage:=TikiPage newFrom:'#fruit apples bananas #pets dog cat bear'."
temp :=TikiPage newFrom:'#red car apple stopsign mars #blue sky ocean blueberry' id: #temp summary: 'testing pop-up window'.
self initializeSpanish.
allPages add: temp! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:54'!
initializeSpanish
"#tenerque Tienes que #infinitives usar #agreement estos ejemplos."
mainPage:=TikiPage newFrom:'#tenerque Tienes que #infinitives usar #agreement estos ejemplos.' id: #main summary: 'An example of a sentence'.
currentPage:=mainPage.
mainInput:='#tenerque Tienes que #infinitive usar #agreement estos ejemplos'.

tenerquePage:=TikiPage newFrom:'Tener que is an expression which means (have to). It is used by conjugating the verb #tener tener ' id: #tenerque summary: 'Tener que means (have to)'.
infinitivePage:=TikiPage newFrom:'Inifinitives refer to the verb without a subject. They literally translate as (to ___) and can be used in expressions such as #tenerque (tener que)' id:#infinitive summary:'Infinitives refer to the (to ___) verb form'.
agreementPage:=TikiPage newFrom:'#nolink Note that adjectives need to agree with the nouns they are modifying, so a masculine noun requires a masculine adjective or adverb.' id:#agreement summary: 'The adjective/adverb must agree with the noun'.
tenerPage:=TikiPage newFrom:'#nolink Tener is the verb which means (to have) and is an irregular verb.' id:#tener summary:'Tener means to have'.
allPages:=OrderedCollection newFrom:{mainPage. tenerquePage. infinitivePage. agreementPage. tenerPage}.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:52'!
processSummaryClick: aSymbol
	"(aSymbol=#nolink) ifFalse:["
		currentPage:=(self findPageWithId: aSymbol among: allPages).
	"]"! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:52'!
processTagClick: aSymbol 
	"(aSymbol=#nolink) ifFalse:["
		expanded=aSymbol ifTrue:[currentPage:=(self findPageWithId: aSymbol among: allPages). expanded:=''] ifFalse:	[expanded:=aSymbol.]
	"]"
	"self inform: 'You clicked on ',( aSymbol asString)"! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:06'!
renderContentOn: html 
		html heading: 'TextClicking '.
		html break.
		html text: mainInput asString.
		html break.
		"this doesn't update currently"
		html form:[
			editting ifTrue:[	html textInput
			on: #mainInput of: self] ifFalse:[
		(currentPage orderedLinks) do:[:each |
			html anchor
				callback: [self processTagClick: (each asSymbol)];
				with: ((currentPage linkDictionary) at: each ifAbsent: ['(',each asString,')']).
			html text:' '.
			(each=expanded) ifTrue: [html anchor 
				callback: [ self processSummaryClick: (each asSymbol)];
				with: ' (',((self findPageWithId: (each asSymbol) among:allPages) summary),') '] .
			html text:' '.
			]
		].
		html break.
		html submitButton 
			callback: [ "self inform: mainInput." editting ifFalse:[editting:=true] ifTrue:[editting:=false. currentPage makeLinkDictionaryFrom: mainInput]];
			text: (editting ifTrue: ['Submit new links'] ifFalse: [ 'Start editting' ]).
			].
		html break.
		html anchor
			callback: [ self processSummaryClick: #temp ];
			with: 'Test pop-up window'.
			! !

TikiWeb subclass: #TikiWebPopupWindow
	instanceVariableNames: 'allPages mainInput currentPage editting expanded tenerquePage tenerPage infinitivePage agreementPage mainPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
canBeRoot
^true! !

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
initialize
	super initialize! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 22:07'!
dialogContentFor: aSymbal
	^('You clicked on ',aSymbal asString,' objects')! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
findPageWithId: anID among: pagesCollection 
"This should be replaced when ID checking improves"
^(pagesCollection detect: [:eachpage| eachpage id = anID] ifNone: mainPage).! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:16'!
initialize
| temp |
super initialize.
editting:=false.
mainInput:='Test input'.
"currentPage:=TikiPage newFrom:'#fruit apples bananas #pets dog cat bear'."
temp :=TikiPage newFrom:'#red car apple stopsign mars #blue sky ocean blueberry' id: #temp summary: 'testing pop-up window'.
self initializeSpanish.
allPages add: temp.
currentPage := temp ! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
initializeSpanish
"#tenerque Tienes que #infinitives usar #agreement estos ejemplos."
mainPage:=TikiPage newFrom:'#tenerque Tienes que #infinitives usar #agreement estos ejemplos.' id: #main summary: 'An example of a sentence'.
currentPage:=mainPage.
mainInput:='#tenerque Tienes que #infinitive usar #agreement estos ejemplos'.

tenerquePage:=TikiPage newFrom:'Tener que is an expression which means (have to). It is used by conjugating the verb #tener tener ' id: #tenerque summary: 'Tener que means (have to)'.
infinitivePage:=TikiPage newFrom:'Inifinitives refer to the verb without a subject. They literally translate as (to ___) and can be used in expressions such as #tenerque (tener que)' id:#infinitive summary:'Infinitives refer to the (to ___) verb form'.
agreementPage:=TikiPage newFrom:'#nolink Note that adjectives need to agree with the nouns they are modifying, so a masculine noun requires a masculine adjective or adverb.' id:#agreement summary: 'The adjective/adverb must agree with the noun'.
tenerPage:=TikiPage newFrom:'#nolink Tener is the verb which means (to have) and is an irregular verb.' id:#tener summary:'Tener means to have'.
allPages:=OrderedCollection newFrom:{mainPage. tenerquePage. infinitivePage. agreementPage. tenerPage}.! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput
^mainInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
processSummaryClick: aSymbol
	"(aSymbol=#nolink) ifFalse:["
		currentPage:=(self findPageWithId: aSymbol among: allPages).
	"]"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
processTagClick: aSymbol 
	"(aSymbol=#nolink) ifFalse:["
		expanded=aSymbol ifTrue:[currentPage:=(self findPageWithId: aSymbol among: allPages). expanded:=''] ifFalse:	[expanded:=aSymbol.]
	"]"
	"self inform: 'You clicked on ',( aSymbol asString)"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/6/2013 12:42'!
renderBox: aString on: html with: contentString
	html div id: aString; class: 'box'; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: contentString ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 22:08'!
renderContentOn: html 
	 | id anchorId|
	html heading: 'Chapter 1 Seciont 2: Spanish '.
	html break.

	html code
		id: #tempID;
		with: DateAndTime now.
		
	html break.

	html div
		id: (id := html nextId);
		script: (html jQuery new dialog
     			title: '';
	     		autoOpen: false);
     		with: [ self renderDialogOn: html].

	html  anchor
			id: (anchorId := html nextId);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #red) ]
						);
			onClick: ((html jQuery id: id) dialog
						open
						);
			with: 'car apple stopsign mars'.
	html break.
	html  anchor
			id: (anchorId := html nextId);
			onClick: ((html jQuery id: id) dialog
						open
						);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #blue) ]
						);
			with: 'sky ocean blueberry'.


! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 21:09'!
renderDialogOn: html
	html div id: (html nextId); class: 'box'; with: [
		html div class: 'header'.
		html div
			id: #boxcontent;
			class: 'content';
			with: 'Brief explanation, cross references, all forum posts about this, etc' ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 20:26'!
style 
	^'
	body { 
	margin: 0;
	font: 11px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
	background: url(background.gif) repeat-x #fff;
}
img {
	border: 0px;
}

#header {
	height: 110px;
	text-align: right;
	background: url(SUAllTestLibrary / #headerGif ) #7e9e50;
	color: #333;
	margin-bottom:25px;
}

#logo {
	float: left;
}

#menu {
	list-style-type: none;
	position: absolute;
	right: 0px;
	top: 95px;
	margin: 0px;
	padding: 0px;
	margin-top: -10px;
	padding-right: 5px;
}

#menu li {
	text-transform: lowercase;
	float: left;
}

#menu li a {
	display: block;
	width: 110px;
	padding-top: 9px;
	height: 16px;
	text-align: center;
	text-decoration: none;
	color: #fff;
	font-weight: bold;
	background: url(menu.gif) 110px 0px;
}

#menu a.active {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#menu a:hover {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#content {
	margin-left: 60px;
	margin-right: 60px;
}

#content h1 {
	font: 22px Georgia, serif;
	color: #7e9e50;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	text-transform: lowercase;
	font-style: italic;
	padding-bottom: 4px;
	border-bottom: 1px dotted #c5dea1;
	clear: left;
}

#content h2 {
	font: 18px Georgia, serif;
	color: #7e9e50;
	font-size: 15px;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	margin-top: 20px;
	text-transform: lowercase;
	font-style: italic;
}

#content h3 {
	font: 13px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
	margin: 0px;
	padding: 0px;
	margin-left: 10px;
	margin-top: 10px;
	font-weight: bold;
	text-transform: lowercase;
	color: #444444;
}

#content p, div.paragraph {
	font-size: 12px;
	line-height: 1.7;
	color: #444444;
	margin-left: 10px;
	margin-top: 10px;
}

/* demo box */
div.box {
	width: 120px;
	height: 120px;
	margin-right: 10px;
	margin-bottom: 10px;

}

div.box div.header {
	height: 23px;
	/*background: url(SUAllTestLibrary / #headerGif) repeat-x;*/
	background: #7e9e50;
}

div.box div.content {
	padding-top: 1em;
	text-align: center;
	/*background: url(SUAllTestLibrary / #demoGif);*/
	background: #f5f5f5;
}

div.smallBox {
	width: 100%;
	height: 100%;
	background: url(demo.gif) ;
}

div.smallBox div.header {
	height: 20px;
	background: url(demo-logo.gif) repeat-x;
}
div.smallBox div.content {
	padding-top: 1em;
	text-align: center;
}

/* source code */
div.source {
	margin: 5px;
	padding: 5px;
	border: 1px solid #dddddd;
	background: #f5f5f5;
	font: 12px Lucida Sans Typewriter, Courier, monospace;
}
a:link {color:black; text-decoration:none}
a:visited{color:black; text-decoration:none}
a:hover { color:gray; text-decoration:none} 
a:active { color:black; text-decoration:none}
'! !
TikiWebPopupWindow initialize!
TikiWebMain initialize!
